/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003  Ciaran Anscomb
 *
 *  See LICENSE for redistribution conditions. */

#ifndef __M6809_H__
#define __M6809_H__

#include <SDL/SDL_types.h>

/* Either there's something wrong with my sound code, or there's something
 * funny about the Dragon's clock.  I've looked at the crystal and it's
 * definitely 14.31818MHz (this * 16) - but for some reason everything is
 * too fast unless I reduce the clock to 5/6 of what I think it should be
 * (a guess based on PAL vs NTSC framerates that happens to make everything
 * sound really good). */

/* #define M6809_CPU_RATE 894886.25 */
#define M6809_CPU_RATE 745738.54166

typedef union {
	Uint16 reg_d;
	struct {
#if __BYTE_ORDER == __LITTLE_ENDIAN
		Uint8 reg_b;
		Uint8 reg_a;
#else
		Uint8 reg_a;
		Uint8 reg_b;
#endif
	} reg_ab;
} accumulator_t;

extern int trace;
extern Uint8 reg_cc, reg_dp;
extern Uint16 reg_x, reg_y, reg_u, reg_s, reg_pc;
extern accumulator_t reg_accum;

void m6809_init(void);
void m6809_reset(void);
void m6809_cycle(void);

#endif  /* __M6809_H__ */
